// HndGoDrc

//--------------------------
// Program Include
//--------------------------
include "_CControls.c"			// Mario's great work... (www.mscon.de)
include "_HndGoDrcIncl.h"			// Program Includes

//
// HandanGo Dynamic Registration Code handling
//
include "_HndGoDrcCompute.h"		// The include file you include in your source
include "_HndGoDrcCompute.c"		// The module you include in your source
//
// To calculate DRC simply call this function:
// 	CalculateDRC(string CDUI, string Formula);
// Where CDUI is the owner's name obtained via get getsysval(0) and Formula is your RPN String.
// See http://www.handango.com / Software Partners for more details.


//
// Other useful includes for this testing application
//
include "_HndGoDrcFnct.c"			// General local functions
include "_HndGoDrcFrms.c"			// Forms handling (create & destroy)
include "_HndGoDrcMtds.c"			// Methods


//--------------------------------------
// Main program
//--------------------------------------
main() {
int rc;
	Startup();
	NxtFrgmnt = Welcome;
	while (1) {
		switch (NxtFrgmnt) {
			case Welcome:
				// Welcome SplashScreen
				BuildForm(Void, Welcome);   // Creates Welcome Form
				break;
				
			case Menu:
				// Menu' 
				BuildForm(CurrentForm, Menu);   // Creates Menu'
				break;
				
			case Settings:
				// Table's Configuration
				CurrentTable = CDUI;	// Sets default Table
				BuildForm(Menu, Settings);   // Destroys Menu' & Creates Settings form
				ShowTable(CurrentTable);
				break;

			case Compute:
				// Compute the DRC
				BuildForm(Menu, Compute);   // Destroys Menu' & Creates Settings form
				break;
				
			default:
				break;
		}
		// Generalized wait states handling
		switch (CurrentForm) {
			case Welcome:
				fWlc_MessageLoop();
				break;
				
			case Menu:
				fMnu_MessageLoop();
				break;
				
			case Settings:
				fStn_MessageLoop();
				break;
				
			case Compute:
				fCmp_MessageLoop();
				break;
				
			default:
		}
	}
}
		