// HndGoDrc Methods


//----------------------------------------
// Menu' methods
//----------------------------------------
on_Mbar(string Bar){
int e, rc;
string s;
	if (Bar == "About") {
		// Shows About Form and wait for a key...
		saveg();
		fAbt_initcontrols();
		fAbt_initcontents();
		fAbt_drawcontrols();
		while(1){
			e=event(1);
			if (Cevent(Abt_BtnOK,e)) {
				restoreg();
				return;
			}
		}
	}	
}


//----------------------------------------
// Compute Form
//----------------------------------------

on_fCmp_btnCompute(){
string lCDUI, lFormula, DRC;
	// Get the parameters (CDUI & Formula)
	lCDUI = Cgetcontent(fCmp_ddnCDUI);
	lFormula = Cgetcontent(fCmp_ddnRPN);
	// Call the computation routine
	DRC = CalculateDRC(lCDUI, lFormula);
	// Show the calculated DRC
	Csetcontent(fCmp_lDRC, DRC);
	Cdraw(fCmp_lDRC);
}

on_fCmp_lDRC(){
}

on_fCmp_btnQuit(){
	NxtFrgmnt = Menu;
}

on_fCmp_ddnCDUI(){
}

on_fCmp_ddnRPN(){
}

//- End Compute Form ---------------------

//-----------------------------------------------
// fCmp_MessageLoop - Handles wait states
//-----------------------------------------------
fCmp_MessageLoop(){
	int e;
	while(1){
		e=event(1);
		if(Cevent(fCmp_btnCompute,e)) {
			on_fCmp_btnCompute();
		} else {
			if(Cevent(fCmp_lDRC,e)) {
				on_fCmp_lDRC();
			} else {
				if(Cevent(fCmp_btnQuit,e)) {
					on_fCmp_btnQuit();
					return;
				} else {
					if(Cevent(fCmp_ddnCDUI,e)) {
						on_fCmp_ddnCDUI();
					} else {
						if(Cevent(fCmp_ddnRPN,e)) {
							on_fCmp_ddnRPN();
						} else {
							if(Cevent(Mbar,e)) {
								on_Mbar(Cgetcontent(Mbar));
							}	
						}
					}
				}
			}
		}
	}
}


//----------------------------------------
// Welcome Form
//----------------------------------------
on_fWlc_bStart() {
 	NxtFrgmnt = Menu;
}
//- End Welcome Form ---------------------

//-----------------------------------------------
// fWlc_MessageLoop - Handles wait states
//-----------------------------------------------
fWlc_MessageLoop() {
int e;
	while(1) {
		e=event(1);
		if(Cevent(fWlc_bStart,e)) {
			on_fWlc_bStart();
			return;
		} else {
			if(Cevent(Mbar,e)) {
				on_Mbar(Cgetcontent(Mbar));
			}	
		}
	}
}
// - end fWlc_MessageLoop -----------------------------

//----------------------------------------
// Menu Form
//----------------------------------------
on_fMnu_bSettings() {
	NxtFrgmnt = Settings;
}

on_fMnu_bCompute() {
	NxtFrgmnt = Compute;
}
//- End Menu Form -  ---------------------

//-----------------------------------------------
// fMnu_MessageLoop - Handles wait states
//-----------------------------------------------
fMnu_MessageLoop() {
int e;
	while(1) {
		e=event(1);
		if(Cevent(fMnu_bCompute,e)) {
			on_fMnu_bCompute();
			return;
		} else {
			if(Cevent(fMnu_bSettings,e)) {
				on_fMnu_bSettings();
				return;
			} else {
				if(Cevent(Mbar,e)) {
					on_Mbar(Cgetcontent(Mbar));
				}	
			}
		}	
	}
}
// - end fMnu_MessageLoop -----------------------------


//----------------------------------------
// Settings Form
//----------------------------------------
on_fStn_dTableSelector(){
string SelTable;
	// Closes current DB
	dbclose();
	// Choose the table to work on
	SelTable = Cgetcontent(fStn_dTableSelector);
	if (SelTable == "C/DUI") {
		CurrentTable = CDUI;
	} else {
		if (SelTable == "Formulas") {
			CurrentTable = Formulas;
		}
	}
	// Switch to the choosen table
	PleaseDestroyTB();	// Clear Table
	ShowTable(CurrentTable);
	return;
}

on_fStn_iTableItems(){
	// 
}

on_fStn_bNew(){
int rc;
string s;
pointer PtrData;
	s = gets("Enter item's content: ");
	if (s != "") {
		PtrData = malloct(1, MskTableDB);
		PtrData[0] = s;
		dbrec(-1);
		dbwritex(PtrData, MskTableDB);	
		free(PtrData);
		PleaseDestroyTB();	// Clear Table
		// Updates Recno Counter...
		switch(CurrentTable) {
			case Formulas: 
				FormulaDBRecno = dbnrecs();
				break;
			case CDUI:
				CDUIDBRecno = dbnrecs();
				break;
			default:
				break;	
		}
		ShowTable(CurrentTable);
	}
}

on_fStn_bEdit(){
int Item;
string s;
pointer PtrData;
	// Let's verify that we have records...
	if(ATableWasBuilt) {
		Item = Cgetcursel(fStn_iTableItems);
		if (Item == -1) {
			alert ("No record selected...");
		} else {
			PtrData = malloct(1, MskTableDB);
			PtrData[0] = "";
			dbrec(Item);
			dbreadx(PtrData, MskTableDB);	
			s = PtrData[0];
			// Modify only Description
			s = getsd("Enter Description: ", s);
			if (s != "") {
				PtrData[0] =  s;
				dbrec(Item);
				dbwritex(PtrData, MskTableDB);	
				PleaseDestroyTB();	// Clear Table
				ShowTable(CurrentTable);
			}
			free (PtrData);
		}
	} else {
		alert ("No records in table...");
	}
}

on_fStn_bDelete(){
int Item;
	// Let's verify that we have records to delete...
	if (ATableWasBuilt) {
		Item = Cgetcursel(fStn_iTableItems);
		if (Item == -1) {
			alert ("No record selected...");
		} else {
			if (confirm("Are you sure to delete this record?")) {
				dbremrec(Item);
				PleaseDestroyTB();	// Clear Table
				// Updates Recno Counter...
				switch(CurrentTable) {
					case Formulas: 
						FormulaDBRecno = dbnrecs();
						break;
					case CDUI:
						CDUIDBRecno = dbnrecs();
						break;
					default:
						break;	
				}
				ShowTable(CurrentTable);
			}
		}
	} else {
		alert ("No records in table...");
	}
}


on_fStn_bQuit(){
	// Let's close DB
	dbclose();
	// Go back to Menu'
	NxtFrgmnt = Menu;	
	// Destroy mallocated
	free(PtrDataTB);
}

//- End Settings Form ---------------------

//-----------------------------------------------
// fStn_MessageLoop - Handles wait states
//-----------------------------------------------
fStn_MessageLoop(){
int e;
	while(1){
		e=event(1);
		if(Cevent(fStn_dTableSelector,e)) {
			on_fStn_dTableSelector();
		} else {
			if(Cevent(fStn_iTableItems,e)) {
				on_fStn_iTableItems();
			} else {
				if(Cevent(fStn_bNew,e)) {
					on_fStn_bNew();
				} else {
					if(Cevent(fStn_bEdit,e)) {
						on_fStn_bEdit();
					} else {
						if(Cevent(fStn_bQuit,e)) {
							on_fStn_bQuit();
							return;
						} else {
							if(Cevent(fStn_bDelete,e)) {
								on_fStn_bDelete();
							} else {					
								if(Cevent(Mbar,e)) {
									on_Mbar(Cgetcontent(Mbar));
								}
							}		
						}
					}
				}
			}
		}
	}
}
// - end fStn_MessageLoop -----------------------------


